﻿using System;
using System.Collections.Generic;
using System.Drawing.Text;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PIbd_22_Kalyshev_Y_V_MotorBoat_Base
{
    /// <summary>
    /// Расширение для класса DrawningBoat
    /// </summary>
    internal static class ExtentionBoat
    {
        /// <summary>
        /// Разделитель для записи информации по объекту в файл
        /// </summary>
        private static readonly char _separatorForObject = ':';
        /// <summary>
        /// Создание объекта из строки
        /// </summary>
        /// <param name="info"></param>
        /// <returns></returns>
        public static DrawningBoat CreateDrawningBoat(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawningBoat(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 7)
            {
                return new DrawningSpeedboat(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
                Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]));
            }
            return null;
        }
        /// <summary>
        /// Получение данных для сохранения в файл
        /// </summary>
        /// <param name="drawningBoat"></param>
        /// <returns></returns>
        public static string GetDataForSave (this DrawningBoat drawningBoat)
        {
            var boat = drawningBoat.Boat;
            var str = $"{boat.Speed}{_separatorForObject}{boat.Weight}{_separatorForObject}{boat.BodyColor.Name}";
            if (boat is not EntitySpeedboat speedboat)
            {
                return str;
            }
            return $"{str}{_separatorForObject}{speedboat.DopColor.Name}{_separatorForObject}{speedboat.BodyKit}{_separatorForObject}{speedboat.Wing}{_separatorForObject}{speedboat.SportLine}";
        }
    }
}
