namespace PIbd_22_Kalyshev_Y_V_MotorBoat_Base
{
    public partial class FormBoat : Form
    {
        private DrawningBoat _boat;

        /// <summary>
        ///  
        /// </summary>
        public DrawningBoat SelectedBoat { get; private set; }
        public FormBoat()
        {
            InitializeComponent();
        }
        /// <summary>
		///   
		/// </summary>
		private void Draw()
        {
            Bitmap bmp = new(pictureBoxBoat.Width, pictureBoxBoat.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _boat?.DrawTransport(gr);
            pictureBoxBoat.Image = bmp;
        }
        /// <summary>
		///   
		/// </summary>
		private void SetData()
        {
            Random rnd = new Random();
            _boat.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxBoat.Width, pictureBoxBoat.Height);
            toolStripStatusLabelSpeed.Text = $": {_boat.Boat.Speed}";
            toolStripStatusLabelWeight.Text = $": {_boat.Boat.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_boat.Boat.BodyColor.Name}";
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
           Random rnd = new();
            _boat = new DrawningBoat(rnd.Next(5, 30), rnd.Next(30, 100), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)));
            SetData();
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _boat?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _boat?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _boat?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _boat?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PictureBoxBoat_Resize(object sender, EventArgs e)
        {
            _boat?.ChangeBorders(pictureBoxBoat.Width, pictureBoxBoat.Height);
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreateModif_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            _boat = new DrawningSpeedboat(rnd.Next(5, 30), rnd.Next(30, 100), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)), Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonSelectBoat_Click(object sender, EventArgs e)
        {
            SelectedBoat = _boat;
            DialogResult = DialogResult.OK;
        }
    }
}